package com.person.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;

import com.person.dao.PersonDao;
import com.person.dao.impl.PersonDaoImpl;
import com.person.domain.PageBean;
import com.person.domain.Person;
import com.person.service.PersonService;

public class PersonServiceImpl implements PersonService {

	//ע
	public int registerPerson(Person p) {
		//dao
		PersonDao dao = new PersonDaoImpl();
		//Ψһֵ
		String pid = UUID.randomUUID().toString();
		p.setPid(pid);
		//жûǷظ
		if(dao.panduanUsername(p)) {
			dao.register(p);
		}else {
			return -1;
		}
		return 1;
	}

	//¼
	public Person loginUser(Person p) {
		//dao
		PersonDao dao = new PersonDaoImpl();
		return dao.login(p);
	}

	//װҳݵpageBean
	public PageBean findAllPage(int current) {
		PageBean pageBean = new PageBean();
		//ǰҳ
		pageBean.setCurrentPage(current);
		//ܼ¼
		PersonDao dao = new PersonDaoImpl();
		int totalCount = dao.findCount();
		pageBean.setTotalCount(totalCount);
		
		//ÿҳʾ¼
		int pageSize = 3;
		//ҳ
		int totalPage = 0;
		if(totalCount%pageSize==0) {
			totalPage = totalCount/pageSize;
		}else {
			totalPage = totalCount/pageSize + 1;
		}
		pageBean.setTotalPage(totalPage);
		
		//ʼλ
		int begin = (current-1) * pageSize;
		pageBean.setBegin(begin);
		
		//ÿҳlist
		List<Person> list = dao.findAllPage(begin, pageSize);
		pageBean.setList(list);
		
		return pageBean;
	}

	public Person findOne(String pid) {
		PersonDao dao = new PersonDaoImpl();
		return dao.findOne(pid);
	}

	public void update(Person p) {
		//dao
		PersonDao dao = new PersonDaoImpl();
		dao.update(p);
		
	}

	public void delete(String pid) {
		//dao
		PersonDao dao = new PersonDaoImpl();
		dao.delete(pid);		
		
	}

	public PageBean selectPerson(Person p, int current) {
		Map<String, String> map = new HashMap<String, String>();
		map.put("realname", p.getRealname());
		map.put("gender", p.getGender());
		map.put("education", p.getEducation());
		String resume = p.getResume();
		
		PageBean pageBean = new PageBean();
		pageBean.setRealname(p.getRealname());
		pageBean.setGender(p.getGender());
		pageBean.setEducation(p.getEducation());
		if(resume.equals("1")) {
			map.put("resume", "is not null");
			pageBean.setResume("1");
		}else if (resume.equals("2")) {
			map.put("resume", "is null");
			pageBean.setResume("2");
		}
		PersonDao dao = new PersonDaoImpl();
		//ܼ¼
		int totalCount = dao.selectCount(map);
		pageBean.setTotalCount(totalCount);
		//ܼ¼0Ÿcurrentֵ,ǰҳ
		if(totalCount > 0) {
			pageBean.setCurrentPage(current);
		}else {
			pageBean.setCurrentPage(0);
		}
		
		//ÿҳʾ¼
		int pageSize = 3;
		//ҳ
		int totalPage = 0;
		if(totalCount%pageSize==0) {
			totalPage = totalCount/pageSize;
		}else {
			totalPage = totalCount/pageSize + 1;
		}
		pageBean.setTotalPage(totalPage);
		
		//ʼλ
		int begin = (current-1) * pageSize;
		pageBean.setBegin(begin);
		
		//ÿҳlist
		List<Person> list = dao.selectPerson(map, begin, pageSize);
		pageBean.setList(list);
		
		return pageBean;
	}

	public void addPerson(Person p) {
		//dao
		PersonDao dao = new PersonDaoImpl();
		//Ψһֵ
		String pid = UUID.randomUUID().toString();
		p.setPid(pid);
		dao.addPerson(p);
	}
}
