package com.person.web;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;

import com.person.domain.Person;
import com.person.service.PersonService;
import com.person.service.impl.PersonServiceImpl;

/**
 * Servlet implementation class AddPersonServlet
 */
public class AddPersonServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		//ļ
		DiskFileItemFactory diskFileItemFactory = new DiskFileItemFactory();		
		//ϴ
		ServletFileUpload servletFileUpload = new ServletFileUpload(diskFileItemFactory);		
		//Map
		Map<String, String> map = new HashMap();		
		String filename = "";		
		//request
		try {
			List<FileItem> list = servletFileUpload.parseRequest(request);
			//ȡ
			for (FileItem fileItem : list) {
				//жͨļ
				if(fileItem.isFormField()) {
					//ȡֵ
					map.put(fileItem.getFieldName(), fileItem.getString("utf-8"));
				}else {
					//ļϴ
					//ļ
					filename = fileItem.getName();
					//еȡļƴ· C:\aa\a.txt
					int lens = filename.lastIndexOf("\\");
					if(lens != -1) {
						filename = filename.substring(lens+1);
					}
					//
					InputStream in = fileItem.getInputStream();
					//·
					String path = this.getServletContext().getRealPath("/upload");
					//
					OutputStream out = new FileOutputStream(path+"/"+filename);
					//Խ
					int len = 0;
					byte[] b = new byte[1024];
					while((len = in.read(b)) != -1) {
						out.write(b, 0, len);
					}
					in.close();
					out.close();
				}
			}
			//ݷŵmapmapݷװJavabean
			Person p = new Person();
			BeanUtils.populate(p, map);
			//pid
			String pid = UUID.randomUUID().toString();
			p.setPid(pid);
			//resume·
			p.setResume("/upload/"+filename);			
			//service
			PersonService service = new PersonServiceImpl();
			service.addPerson(p);			
			//תб
			request.getRequestDispatcher("/person?method=list&currentPage=1").forward(request, response);
			return;			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doGet(request, response);
	}

}
