package com.person.web;

import java.lang.reflect.InvocationTargetException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.beanutils.BeanUtils;

import com.person.domain.PageBean;
import com.person.domain.Person;
import com.person.service.PersonService;
import com.person.service.impl.PersonServiceImpl;

/**
 * Servlet implementation class PersonServlet
 */
public class PersonServlet extends BaseServlet {

	//עķ
	public String register(HttpServletRequest request, HttpServletResponse response) {
		//ȡύ
		Person p = new Person();
		try {
			//BeanUtilsѱݷװjavabean 
			BeanUtils.populate(p, request.getParameterMap());
			//service
			PersonService personService = new PersonServiceImpl();
			int id = personService.registerPerson(p);
			p.setId(id);
			request.setAttribute("p", p);
			if(id == -1) {
				return "/login/register.jsp";
			}
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}
		return "/login/login.jsp";
	}
	
	//¼ķ
	public String login(HttpServletRequest request, HttpServletResponse response) {
		//ȡύ
		Person p = new Person();
		//BeanUtilsѱݷװjavabean
		try {
			BeanUtils.populate(p, request.getParameterMap());
			//service
			PersonService personService = new PersonServiceImpl();
			Person person = personService.loginUser(p);
			//ж
			if(person != null) {//ɹ
				HttpSession session =  request.getSession();
				session.setAttribute("person", person);
				return "/login/home.jsp";
			}else {
				return "/login/login.jsp";
			}
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	//Աбķ
	public String list(HttpServletRequest request, HttpServletResponse response) {
		//ȡǰҳ
		String currentPage = request.getParameter("currentPage");
		int current  = 1;
		if(currentPage != null && !"".equals(currentPage)) {
			current = Integer.parseInt(currentPage);
		}
		//service
		PersonService personService = new PersonServiceImpl();
		PageBean pageBean = personService.findAllPage(current);
		//ݵҳʾ
		request.setAttribute("pageBean", pageBean);
		return "/user/list.jsp";
		
	}
	
	//޸ҳʾ
	public String toUpdatePage(HttpServletRequest request, HttpServletResponse response) {
		//ȡԱid
		String pid = request.getParameter("pid");
		//pidѯԱϢ
		PersonService service = new PersonServiceImpl();
		Person p = service.findOne(pid);
		//ѷֵҳʾ
		request.setAttribute("p", p);
		return "/user/edit.jsp";
	}
	
	//鿴ԱϢķ
	public String viewPerson(HttpServletRequest request, HttpServletResponse response) {
		//ȡԱid
		String pid = request.getParameter("pid");
		//pidѯԱϢ
		PersonService service = new PersonServiceImpl();
		Person p = service.findOne(pid);
		//ѷֵҳʾ
		request.setAttribute("p", p);
		return "/user/view.jsp";
	}
	
	//ѯԱķ
	public String selectPerson(HttpServletRequest request, HttpServletResponse response) {
		//ȡύ
		Person p = new Person();
		try {
			BeanUtils.populate(p, request.getParameterMap());
			//ȡǰҳ
			String currentPage = request.getParameter("currentPage");
			int current  = 1;
			if(currentPage != null && !"".equals(currentPage)) {
				current = Integer.parseInt(currentPage);
			}
			//service
			PersonService personService = new PersonServiceImpl();
			PageBean pageBean = personService.selectPerson(p,current);
			//ݵҳʾ
			request.setAttribute("pageBean", pageBean);
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}
		return "/user/select.jsp";
	}
	
	//޸Աķ
	public String update(HttpServletRequest request, HttpServletResponse response) {
		//ȡύݣװjavabean
		Person p = new Person();
		try {
			BeanUtils.populate(p, request.getParameterMap());
			//service
			PersonService personService = new PersonServiceImpl();
			personService.update(p);
			return "/person?method=list";
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) { 
			e.printStackTrace();
		}
		return null;
	}
	
	//ɾԱķ
	public String delete(HttpServletRequest request, HttpServletResponse response) {
		//ȡԱid
		String pid = request.getParameter("pid");
		//pidѯԱϢ
		PersonService service = new PersonServiceImpl();
		service.delete(pid);
		return "/person?method=list";
	}
}
